{ File   : LISTE.INC
  Author : Deniz Oezmen
  Created: 1999-09-25
  Changed: 2005-08-25

  Include file for list functionality.
}
type
  TListenZeiger  = ^TListenElement;

  TListenElement = record
                     Element: TElement;
                     Next   : TListenZeiger
                   end;

  TListe         = record
                     Kopf,
                     Aktuell: TListenZeiger
                   end;

procedure l_create(var Liste: TListe);
begin
  Liste.Kopf := nil;
  Liste.Aktuell := nil
end;

function l_empty(Liste: TListe) : Boolean;
begin
  l_empty := (Liste.Kopf = nil)
end;

procedure l_insert(var Liste: TListe; Element: TElement);
var
  TempZeiger,
  LaufZeiger: TListenZeiger;
begin
  New(TempZeiger);
  TempZeiger^.Element := Element;
  TempZeiger^.Next := Liste.Aktuell;

  if (Liste.Kopf = Liste.Aktuell) then
    Liste.Kopf := TempZeiger
  else
  begin
    LaufZeiger := Liste.Kopf;
    while LaufZeiger^.Next <> Liste.Aktuell do
      LaufZeiger := LaufZeiger^.Next;
    LaufZeiger^.Next := TempZeiger
  end;
  Liste.aktuell := TempZeiger
end;

procedure l_show(Liste: TListe; var Element: TElement);
var
  TempZeiger: TListenZeiger;
begin
  if not l_empty(Liste) then
  begin
    TempZeiger := Liste.Aktuell;
    Element := TempZeiger^.Element
  end
end;

procedure l_last(var Liste: TListe; Element: TElement);
var
  TempZeiger,
  LaufZeiger : TListenZeiger;
begin
  if not l_empty(Liste) then
  begin
    New(TempZeiger);
    TempZeiger^.Element := Element;
    LaufZeiger := Liste.Kopf;
    while LaufZeiger^.Next <> nil do
      LaufZeiger := LaufZeiger^.Next;
    TempZeiger^.Next := nil;
    LaufZeiger^.Next := TempZeiger;
    Liste.Aktuell := TempZeiger
  end
end;

procedure l_reset(var Liste: TListe);
begin
  if not l_empty(Liste) then
    Liste.Aktuell := Liste.Kopf
end;

procedure l_next(var Liste: TListe);
var
  TempZeiger : TListenZeiger;
begin
  if not l_empty(Liste) then
  begin
    TempZeiger := Liste.Aktuell;
    if TempZeiger^.Next <> nil then
      Liste.Aktuell := TempZeiger^.Next
  end
end;

function l_end(Liste: TListe): Boolean;
var
  TempZeiger : TListenZeiger;
begin
  TempZeiger := Liste.Aktuell;
  l_end := (TempZeiger^.Next = nil)
end;

procedure l_delete(var Liste: TListe);
var
  TempZeiger,
  LaufZeiger : TListenZeiger;
begin
  if not l_empty(Liste) then
  begin
    TempZeiger := Liste.Aktuell;
    if (Liste.Aktuell = Liste.Kopf) then
      Liste.Kopf := TempZeiger^.Next
    else
    begin
      LaufZeiger := Liste.Kopf;
      while LaufZeiger^.Next <> TempZeiger do
        LaufZeiger := LaufZeiger^.Next;
      LaufZeiger^.Next := TempZeiger^.Next
    end;
    Liste.Aktuell := Liste.Kopf;
    Dispose(TempZeiger)
  end
end;